' ==============================================================================
' MeteoPT - informacoes do estado do tempo de www.meteo.pt
' --------------------------------------------------------
' V 1.0 - Versao inicial
'
'    Instrucoes:
'
'      - Colocar esta script na directoria "Scripts" da instalao do Samurize
'      - Alterar os valores das constantes "Regiao" e "Directorio_SAMURIZE" 
'        de acordo com a sua configuracao. 
'      - Utilizar apenas as funcoes iniciadas por "MeteoPT_" para extrair 
'        a informacao para o Samurize
'
' Edgar Delgado Barbosa - edgar@kanguru.pt                            23-06-2006
' ==============================================================================
'
'   Codigo da Regiao
'
'    "1" = Sagres
'    "2" = Faro
'    "3" = Portalegre
'    "4" = vora
'    "5" = Setbal
'    "6" = Sines
'    "7" = Beja
'    "8" = Santa Cruz
'    "9" = Horta
'   "10" = Angra do Herosmo
'   "11" = P. Delgado
'   "12" = Viseu
'   "13" = Guarda
'   "14" = Penhas Douradas
'   "15" = Castelo Branco
'   "16" = Aveiro
'   "17" = Coimbra
'   "18" = Leiria
'   "19" = Santarm
'   "20" = Lisboa
'   "21" = Porto
'   "22" = Funchal
'   "23" = Porto Santo
'   "24" = Viana do Castelo
'   "25" = Braga
'   "26" = Vila Real
'   "27" = Bragana

const Regiao = "24"
const Directorio_SAMURIZE = "C:\Programas\Samurize"
const Intervalo_Actualizacao = 30 'Intervalo de actualizacao em minutos 

' ==============================================================================
' NAO ALTERAR O CODIGO DEPOIS DESTA LINHA
' ==============================================================================

Ficheiro01 = Directorio_SAMURIZE & "\Scripts\MeteoPT01.tmp"
Ficheiro02 = Directorio_SAMURIZE & "\Scripts\MeteoPT02.tmp"
Ficheiro11 = Directorio_SAMURIZE & "\Scripts\MeteoPT11.tmp"
Ficheiro12 = Directorio_SAMURIZE & "\Scripts\MeteoPT12.tmp"
Ficheiro22 = Directorio_SAMURIZE & "\Scripts\MeteoPT22.tmp"

ImgFicheiro01 = Directorio_SAMURIZE & "\Icons\MeteoPT01.gif"
ImgFicheiro02 = Directorio_SAMURIZE & "\Icons\MeteoPT02.gif"
ImgFicheiro11 = Directorio_SAMURIZE & "\Icons\MeteoPT11.gif"
ImgFicheiro12 = Directorio_SAMURIZE & "\Icons\MeteoPT12.gif"
ImgFicheiro22 = Directorio_SAMURIZE & "\Icons\MeteoPT22.gif"

const MeteoPT_URL = "http://www.meteo.pt/pt/previsao/previsaoRegional.jsp"

const TempMinima = "-100"
'===============================================================================
Function MeteoPT_Regiao()
    MeteoPT_Regiao= strRegiao(Regiao)
End Function
'===============================================================================
Function MeteoPT_Data()
    getCacheFile Intervalo_Actualizacao, MeteoPT_URL & "?curSvrPeriodo=0&diaPrev=0&periodo=1&regiao=" & idRegiao(Regiao), Ficheiro01, ImgFicheiro01
    textoFic = textoFicheiro(Ficheiro01)
    MeteoPT_Data = data(textoFic)
End Function
'===============================================================================
Function MeteoPT_ImgActual()
    if am() Then
        if fileType(ImgFicheiro01) = 1 then
            MeteoPT_ImgActual = ImgFicheiro01
        else
            MeteoPT_ImgActual = ""
        End If
    Else
        if fileType(ImgFicheiro02) = 1 then
            MeteoPT_ImgActual = ImgFicheiro02
        else
            MeteoPT_ImgActual = ""
        End If
    End If
End Function
'===============================================================================
Function MeteoPT_Data()
    getCacheFile Intervalo_Actualizacao, MeteoPT_URL & "?curSvrPeriodo=0&diaPrev=0&periodo=1&regiao=" & idRegiao(Regiao), Ficheiro01, ImgFicheiro01
    textoFic = textoFicheiro(Ficheiro01)
    MeteoPT_Data = data(textoFic)
End Function
Function MeteoPT_DiaAmanha()
    MeteoPT_DiaAmanha = strDiaSemana((Weekday(now) mod 7) + 1)
End Function
Function MeteoPT_DiaDepoisDeAmanha()
    MeteoPT_DiaDepoisDeAmanha = strDiaSemana(((Weekday(now) + 1) mod 7) + 1)
End Function
Function teste()
    teste =  nomeImagem(textoFicheiro(Ficheiro01))
End Function
'===============================================================================
Function MeteoPT_ImgHoje_0_12()
    getCacheFile Intervalo_Actualizacao, MeteoPT_URL & "?curSvrPeriodo=0&diaPrev=0&periodo=1&regiao=" & idRegiao(Regiao), Ficheiro01, ImgFicheiro01
    if fileType(ImgFicheiro01) = 1 then
        MeteoPT_ImgHoje_0_12 = ImgFicheiro01
    else
        MeteoPT_ImgHoje_0_12 = ""
    End If
End Function
Function MeteoPT_ImgHoje_12_24()
    getCacheFile Intervalo_Actualizacao, MeteoPT_URL & "?curSvrPeriodo=0&diaPrev=0&periodo=2&regiao=" & idRegiao(Regiao), Ficheiro02, ImgFicheiro02
    if fileType(ImgFicheiro02) = 1 then
        MeteoPT_ImgHoje_12_24 = ImgFicheiro02
    else
        MeteoPT_ImgHoje_12_24 = ""
    End If
End Function
Function MeteoPT_ImgAmanha_0_12()
    getCacheFile Intervalo_Actualizacao, MeteoPT_URL & "?curSvrPeriodo=0&diaPrev=1&periodo=1&regiao=" & idRegiao(Regiao), Ficheiro11, ImgFicheiro11
    if fileType(ImgFicheiro11) = 1 then
        MeteoPT_ImgAmanha_0_12 = ImgFicheiro11
    else
        MeteoPT_ImgAmanha_0_12 = ""
    End If
End Function
Function MeteoPT_ImgAmanha_12_24()
    getCacheFile Intervalo_Actualizacao, MeteoPT_URL & "?curSvrPeriodo=0&diaPrev=1&periodo=2&regiao=" & idRegiao(Regiao), Ficheiro12, ImgFicheiro12
    if fileType(ImgFicheiro12) = 1 then
        MeteoPT_ImgAmanha_12_24 = ImgFicheiro12
    else
        MeteoPT_ImgAmanha_12_24 = ""
    End If
End Function
Function MeteoPT_ImgDepoisDeAmanha()
    getCacheFile Intervalo_Actualizacao, MeteoPT_URL & "?curSvrPeriodo=0&diaPrev=2&periodo=2&regiao=" & idRegiao(Regiao), Ficheiro22, ImgFicheiro22
    if fileType(ImgFicheiro22) = 1 then
        MeteoPT_ImgDepoisDeAmanha = ImgFicheiro22
    else
        MeteoPT_ImgDepoisDeAmanha = ""
    End If
End Function
'===============================================================================
Function MeteoPT_TempMaxActual()
    if am() Then
        MeteoPT_TempMaxActual = MeteoPT_TempMaxHoje_0_12()
    Else
        MeteoPT_TempMaxActual = MeteoPT_TempMaxHoje_12_24()
    End If
End Function
'===============================================================================
Function MeteoPT_TempMaxHoje_0_12()
    getCacheFile Intervalo_Actualizacao, MeteoPT_URL & "?curSvrPeriodo=0&diaPrev=0&periodo=1&regiao=" & idRegiao(Regiao), Ficheiro01, ImgFicheiro01
    MeteoPT_TempMaxHoje_0_12 = tempMax(textoFicheiro(Ficheiro01))
End Function
Function MeteoPT_TempMaxHoje_12_24()
    getCacheFile Intervalo_Actualizacao, MeteoPT_URL & "?curSvrPeriodo=0&diaPrev=0&periodo=2&regiao=" & idRegiao(Regiao), Ficheiro02, ImgFicheiro02
    MeteoPT_TempMaxHoje_12_24 = tempMax(textoFicheiro(Ficheiro02))
End Function
Function MeteoPT_TempMaxAmanha_0_12()
    getCacheFile Intervalo_Actualizacao, MeteoPT_URL & "?curSvrPeriodo=0&diaPrev=1&periodo=1&regiao=" & idRegiao(Regiao), Ficheiro11, ImgFicheiro11
    MeteoPT_TempMaxAmanha_0_12 = tempMax(textoFicheiro(Ficheiro11))
End Function
Function MeteoPT_TempMaxAmanha_12_24()
    getCacheFile Intervalo_Actualizacao, MeteoPT_URL & "?curSvrPeriodo=0&diaPrev=1&periodo=2&regiao=" & idRegiao(Regiao), Ficheiro12, ImgFicheiro12
    MeteoPT_TempMaxAmanha_12_24 = tempMax(textoFicheiro(Ficheiro12))
End Function
Function MeteoPT_TempMaxDepoisDeAmanha()
    getCacheFile Intervalo_Actualizacao, MeteoPT_URL & "?curSvrPeriodo=0&diaPrev=2&periodo=2&regiao=" & idRegiao(Regiao), Ficheiro22, ImgFicheiro22
    MeteoPT_TempMaxDepoisDeAmanha = tempMax(textoFicheiro(Ficheiro22))
End Function
'===============================================================================
Function MeteoPT_TempMinHoje_0_12()
    getCacheFile Intervalo_Actualizacao, MeteoPT_URL & "?curSvrPeriodo=0&diaPrev=0&periodo=1&regiao=" & idRegiao(Regiao), Ficheiro01, ImgFicheiro01
    MeteoPT_TempMinHoje_0_12 = tempMin(textoFicheiro(Ficheiro01))
End Function
Function MeteoPT_TempMinHoje_12_24()
    getCacheFile Intervalo_Actualizacao, MeteoPT_URL & "?curSvrPeriodo=0&diaPrev=0&periodo=2&regiao=" & idRegiao(Regiao), Ficheiro02, ImgFicheiro02
    MeteoPT_TempMinHoje_12_24 = tempMin(textoFicheiro(Ficheiro02))
End Function
Function MeteoPT_TempMinAmanha_0_12()
    getCacheFile Intervalo_Actualizacao, MeteoPT_URL & "?curSvrPeriodo=0&diaPrev=1&periodo=1&regiao=" & idRegiao(Regiao), Ficheiro11, ImgFicheiro11
    MeteoPT_TempMinAmanha_0_12 = tempMin(textoFicheiro(Ficheiro11))
End Function
Function MeteoPT_TempMinAmanha_12_24()
    getCacheFile Intervalo_Actualizacao, MeteoPT_URL & "?curSvrPeriodo=0&diaPrev=1&periodo=2&regiao=" & idRegiao(Regiao), Ficheiro12, ImgFicheiro12
    MeteoPT_TempMinAmanha_12_24 = tempMin(textoFicheiro(Ficheiro12))
End Function
Function MeteoPT_TempMinDepoisDeAmanha()
    getCacheFile Intervalo_Actualizacao, MeteoPT_URL & "?curSvrPeriodo=0&diaPrev=2&periodo=2&regiao=" & idRegiao(Regiao), Ficheiro22, ImgFicheiro22
    MeteoPT_TempMinDepoisDeAmanha = tempMin(textoFicheiro(Ficheiro22))
End Function
'===============================================================================
'===============================================================================
Function MeteoPT_TempMaxHoje_0_12_Neg()
    MeteoPT_TempMaxHoje_0_12_Neg = MeteoPT_TempMaxHoje_0_12
    if Left(MeteoPT_TempMaxHoje_0_12_Neg,1) <> "-" Then MeteoPT_TempMaxHoje_0_12_Neg = TempMinima
End Function
Function MeteoPT_TempMaxHoje_12_24_Neg()
    MeteoPT_TempMaxHoje_12_24_Neg = MeteoPT_TempMaxHoje_12_24
    if Left(MeteoPT_TempMaxHoje_12_24_Neg,1) <> "-" Then MeteoPT_TempMaxHoje_12_24_Neg = TempMinima
End Function
Function MeteoPT_TempMaxAmanha_0_12_Neg()
    MeteoPT_TempMaxAmanha_0_12_Neg = MeteoPT_TempMaxAmanha_0_12
    if Left(MeteoPT_TempMaxAmanha_0_12_Neg,1) <> "-" Then MeteoPT_TempMaxAmanha_0_12_Neg = TempMinima
End Function
Function MeteoPT_TempMaxAmanha_12_24_Neg()
    MeteoPT_TempMaxAmanha_12_24_Neg = MeteoPT_TempMaxAmanha_12_24
    if Left(MeteoPT_TempMaxAmanha_12_24_Neg,1) <> "-" Then MeteoPT_TempMaxAmanha_12_24_Neg = TempMinima
End Function
Function MeteoPT_TempMaxDepoisDeAmanha_Neg()
    MeteoPT_TempMaxDepoisDeAmanha_Neg = MeteoPT_TempMaxDepoisDeAmanha
    if Left(MeteoPT_TempMaxDepoisDeAmanha_Neg,1) <> "-" Then MeteoPT_TempMaxDepoisDeAmanha_Neg = TempMinima
End Function
'===============================================================================
Function MeteoPT_TempMinHoje_0_12_Neg()
    MeteoPT_TempMinHoje_0_12_Neg = MeteoPT_TempMinHoje_0_12
    if Left(MeteoPT_TempMinHoje_0_12_Neg,1) <> "-" Then MeteoPT_TempMinHoje_0_12_Neg = TempMinima
End Function
Function MeteoPT_TempMinHoje_12_24_Neg()
    MeteoPT_TempMinHoje_12_24_Neg = MeteoPT_TempMinHoje_12_24
    if Left(MeteoPT_TempMinHoje_12_24_Neg,1) <> "-" Then MeteoPT_TempMinHoje_12_24_Neg = TempMinima
End Function
Function MeteoPT_TempMinAmanha_0_12_Neg()
    MeteoPT_TempMinAmanha_0_12_Neg = MeteoPT_TempMinAmanha_0_12
    if Left(MeteoPT_TempMinAmanha_0_12_Neg,1) <> "-" Then MeteoPT_TempMinAmanha_0_12_Neg = TempMinima
End Function
Function MeteoPT_TempMinAmanha_12_24_Neg()
    MeteoPT_TempMinAmanha_12_24_Neg = MeteoPT_TempMinAmanha_12_24
    if Left(MeteoPT_TempMinAmanha_12_24_Neg,1) <> "-" Then MeteoPT_TempMinAmanha_12_24_Neg = TempMinima
End Function
Function MeteoPT_TempMinDepoisDeAmanha_Neg()
    MeteoPT_TempMinDepoisDeAmanha_Neg = MeteoPT_TempMinDepoisDeAmanha
    if Left(MeteoPT_TempMinDepoisDeAmanha_Neg,1) <> "-" Then MeteoPT_TempMinDepoisDeAmanha_Neg = TempMinima
End Function
'===============================================================================
Function strRegiao(loc)
  If loc = "1" Then
    strRegiao = "Sagres"
  ElseIf loc = "2" Then
    strRegiao = "Faro"
  ElseIf loc = "3" Then
    strRegiao = "Portalegre"
  ElseIf loc = "4" Then
    strRegiao = "vora"
  ElseIf loc = "5" Then
    strRegiao = "Setbal"
  ElseIf loc = "6" Then
    strRegiao = "Sines"
  ElseIf loc = "7" Then
    strRegiao = "Beja"
  ElseIf loc = "8" Then
    strRegiao = "Santa Cruz"
  ElseIf loc = "9" Then
    strRegiao = "Horta"
  ElseIf loc = "10" Then
    strRegiao = "Angra do Herosmo"
  ElseIf loc = "11" Then
    strRegiao = "P. Delgado"
  ElseIf loc = "12" Then
    strRegiao = "Viseu"
  ElseIf loc = "13" Then
    strRegiao = "Guarda"
  ElseIf loc = "14" Then
    strRegiao = "Penhas Douradas"
  ElseIf loc = "15" Then
    strRegiao = "Castelo Branco"
  ElseIf loc = "16" Then
    strRegiao = "Aveiro"
  ElseIf loc = "17" Then
    strRegiao = "Coimbra"
  ElseIf loc = "18" Then
    strRegiao = "Leiria"
  ElseIf loc = "19" Then
    strRegiao = "Santarm"
  ElseIf loc = "20" Then
    strRegiao = "Lisboa"
  ElseIf loc = "21" Then
    strRegiao = "Porto"
  ElseIf loc = "22" Then
    strRegiao = "Funchal"
  ElseIf loc = "23" Then
    strRegiao = "Porto Santo"
  ElseIf loc = "24" Then
    strRegiao = "Viana do Castelo"
  ElseIf loc = "25" Then
    strRegiao = "Braga"
  ElseIf loc = "26" Then
    strRegiao = "Vila Real"
  ElseIf loc = "27" Then
    strRegiao = "Bragana"
  Else
    strRegiao = "ND"
  End If
End Function
Function strDiaSemana(dia)
  If dia = 1 Then
    strDiaSemana = "DOM"
  ElseIf dia = 2 Then
    strDiaSemana = "SEG"
  ElseIf dia = 3 Then
    strDiaSemana = "TER"
  ElseIf dia = 4 Then
    strDiaSemana = "QUA"
  ElseIf dia = 5 Then
    strDiaSemana = "QUI"
  ElseIf dia = 6 Then
    strDiaSemana = "SEX"
  ElseIf dia = 7 Then
    strDiaSemana = "SAB"
  Else
    strDiaSemana = "N.D."
  End If
End Function 
'===============================================================================
Function idRegiao(loc)
  If loc = "1" Or loc = "2" Then
    idRegiao = "1"
  ElseIf loc = "3" Or loc = "4" Or loc = "5" Or loc = "6" Or loc = "7" Then
    idRegiao = "2"
  ElseIf loc = "8" Or loc = "9" Or loc = "10" Or loc = "11" Then
    idRegiao = "3"
  ElseIf loc = "12" Or loc = "13" Or loc = "14" Or loc = "15" Then
    idRegiao = "4"
  ElseIf loc = "16" Or loc = "17" Or loc = "18" Or loc = "19" Then
    idRegiao = "5"
  ElseIf loc = "20" Then
    idRegiao = "7"
  ElseIf loc = "21" Then
    idRegiao = "8"
  ElseIf loc = "22" Or loc = "23" Then
    idRegiao = "9"
  ElseIf loc = "24" Or loc = "25" Then
    idRegiao = "10"
  ElseIf loc = "26" Or loc = "27" Then
    idRegiao = "11"
  Else
    idRegiao = "ND"
  End If
End Function
'===============================================================================
Function fileType(filename)
    set fso = createobject("scripting.filesystemobject")
    set file = fso.getfile(filename)
    set ts = file.openastextstream(1, -2)
    text = ts.read(3)
    ts.close 
    If text = "GIF" Then
        fileType = 1
    Else
        fileType = 0
    End If
End Function
'===============================================================================
Function SaveWebBinary(strUrl, strFile) 'As Boolean
    Const adTypeBinary = 1
    Const adSaveCreateOverWrite = 2
    Const ForWriting = 2
    Dim web, varByteArray, strData, strBuffer, lngCounter, ado
    SaveWebBinary = False
    
    On Error Resume Next
    'Download the file with any available object
    Err.Clear
    Set web = Nothing
    Set web = CreateObject("WinHttp.WinHttpRequest.5.1")
    If web Is Nothing Then Set web = CreateObject("WinHttp.WinHttpRequest")
    If web Is Nothing Then Set web = CreateObject("MSXML2.ServerXMLHTTP")
    If web Is Nothing Then Set web = CreateObject("Microsoft.XMLHTTP")
    web.Open "GET", strUrl, False
    web.Send
    If Err.Number <> 0 Then
        SaveWebBinary = False
        Set web = Nothing
        Exit Function
    End If
    If web.Status <> "200" Then
        SaveWebBinary = False
        Set web = Nothing
        Exit Function
    End If
    varByteArray = web.ResponseBody
    Set web = Nothing
    'Now save the file with any available method
    On Error Resume Next
    Set ado = Nothing
    Set ado = CreateObject("ADODB.Stream")
    If ado Is Nothing Then
        Set fs = CreateObject("Scripting.FileSystemObject")
        Set ts = fs.OpenTextFile(strFile, ForWriting, True)
        strData = ""
        strBuffer = ""
        For lngCounter = 0 To UBound(varByteArray)
            ts.Write Chr(255 And AscB(MidB(varByteArray, lngCounter + 1, 1)))
        Next
        ts.Close
    Else
        ado.Type = adTypeBinary
        ado.Open
        ado.Write varByteArray
        ado.SaveToFile strFile, adSaveCreateOverWrite
        ado.Close
    End If
    SaveWebBinary = True
End Function
'===============================================================================
Function getCacheFile(mins, fileURL, filename, Imgfilename)
  Dim fs
  Set fs = CreateObject("Scripting.FileSystemObject")
  If (Not fs.FileExists(filename)) Then
    getCacheFile = True
  Else
    Set cacheFile = fs.GetFile(filename)
    getCacheFile = False
    If DateDiff("n", cacheFile.DateLastModified, Now()) >= mins Then
      getCacheFile = True
    End If
  End If
  If getCacheFile Then
    Dim Http, HtmlResult, f
    Set Http = CreateObject("Microsoft.XMLhttp")
    Http.Open "POST", fileURL, False
    Http.Send
    HtmlResult = Http.ResponseText
    Set Http = Nothing
    Set f = fs.CreateTextFile(filename, true, true)
    f.write(HtmlResult)
    f.close
    Set f = nothing
    '====== transfere imagem =============
    SaveWebBinary nomeImagem(textoFicheiro(filename)), Imgfilename
  End If
  Set fs = nothing
 End Function
'===============================================================================
Function textoFicheiro(fileName)
  Dim xmlResult
  Set file_obj = CreateObject("Scripting.FileSystemObject")
  If (file_obj.FileExists(fileName)) Then
    Set file_path = file_obj.GetFile(fileName) ' Creates the connection to the file
    Set file = file_path.OpenAsTextStream (1, -2) ' Opens the file for reading
    xmlResult = file.readall
    File.Close ' Closes the file
    Set file_path = nothing ' Resets variable
    Set file_obj = nothing ' Resets variable
    textoFicheiro = xmlResult
  Else
    textoFicheiro = "ND"
  End If
End Function
'===============================================================================
Function nomeImagem(texto)
On Error Resume Next
    tmpTexto = texto
    fim = InStr(1, tmpTexto, strRegiao(Regiao), 0)
    'inicio = InStrRev(tmpTexto, "img src=", fim, 1)
    inicio = InStrRev(tmpTexto, "<div class=" & Chr(34) & "nuvemDiv" & Chr(34) & "><img src=", fim, 1)
    tmpTexto = Mid(tmpTexto, inicio, fim - inicio)
    fim = InStr(1, tmpTexto, "gif", 1)
    inicio = InStr(1, tmpTexto, "/", 1)
    nomeImagem = "http://www.meteo.pt" & Mid(tmpTexto, inicio, fim - inicio) & "gif"
End Function
'===============================================================================
Function tempMax(texto)
On Error Resume Next
    tmpTexto = texto
    fim = InStr(1, tmpTexto, strRegiao(Regiao), 0)
    inicio = InStrRev(tmpTexto, "tempMax", fim, 1)
    tmpTexto = Mid(tmpTexto, inicio, fim - inicio)
    fim = InStr(1, tmpTexto, "&ordm", 1)
    inicio = InStr(1, tmpTexto, ">", 1) + 1
    tempMax = Trim(Mid(tmpTexto, inicio, fim - inicio))
End Function
'===============================================================================
Function tempMin(texto)
On Error Resume Next
    tmpTexto = texto
    fim = InStr(1, tmpTexto, strRegiao(Regiao), 0)
    inicio = InStrRev(tmpTexto, "tempMin", fim, 1)
    tmpTexto = Mid(tmpTexto, inicio, fim - inicio)
    fim = InStr(1, tmpTexto, "&ordm", 1)
    inicio = InStr(1, tmpTexto, ">", 1) + 1
    tempMin = Trim(Mid(tmpTexto, inicio, fim - inicio))
End Function
'===============================================================================
Function data(texto)
On Error Resume Next
    tmpTexto = texto
    inicio = InStr(1, tmpTexto, "BEM-VINDO,", 1) + 10
    fim = InStr(inicio, tmpTexto, "</td>", 1)
    data = Mid(tmpTexto, inicio, fim - inicio)
End Function
'===============================================================================
Function am()
    myAMPM = Right(Time(),2)
    If myAMPM = "AM" Then
        au = True
    else
        am = False
    End If
End Function
'===============================================================================
